program sstability

  use sep
  use smodeling_mod

  implicit none
  
  real :: dx, dy, dz, dt, dtt, eps1, eps2, del1, del2, del3, vpz, varphi, the, phi
  real :: d, kxdx, kydy, kzdz
  real :: cx2, ccx2, ssx2, cy2, ccy2, ssy2, cz2, ccz2, ssz2
  real :: cx4(2), ccx4(2), ssx4(2), cy4(2), ccy4(2), ssy4(2), cz4(2), ccz4(2), ssz4(2)
  real :: cx6(3), ccx6(3), ssx6(3), cy6(3), ccy6(3), ssy6(3), cz6(3), ccz6(3), ssz6(3)
  real :: cx8(4), ccx8(4), ssx8(4), cy8(4), ccy8(4), ssy8(4), cz8(4), ccz8(4), ssz8(4)
  real :: cx10(5), ccx10(5), ssx10(5), cy10(5), ccy10(5), ssy10(5), cz10(5), ccz10(5), ssz10(5)
  real :: cx12(6), ccx12(6), ssx12(6), cy12(6), ccy12(6), ssy12(6), cz12(6), ccz12(6), ssz12(6)
  real :: cx14(7), ccx14(7), ssx14(7), cy14(7), ccy14(7), ssy14(7), cz14(7), ccz14(7), ssz14(7)
  real :: cx16(8), ccx16(8), ssx16(8), cy16(8), ccy16(8), ssy16(8), cz16(8), ccz16(8), ssz16(8)
  double precision :: A(3,3), B(6,6), I(3,3), wr(6), wi(6), vs(6,6), work(18), eig(101,101,101)
  integer :: sdim, info, i1, i2, i3, l(8), it
  logical :: bwork(6)

  external select

  call sep_init() 

  d = pi/50.

  call from_param("dx", dx)
  call from_param("dy", dy)
  call from_param("dz", dz)

  call from_param("vpz", vpz)
  call from_param("eps1", eps1)
  call from_param("eps2", eps2)
  call from_param("del1", del1)
  call from_param("del2", del2)
  call from_param("del3", del3)
  call from_param("varphi", varphi)
  call from_param("the", the)
  call from_param("phi", phi)
  
  call init_vel(eps1, eps2, del1, del2, del3, vpz, varphi, the, phi)

  I = 0.
  I(1,1) = 1.
  I(2,2) = 1.
  I(3,3) = 1.

  l = (/ 1, 2, 3, 4 , 5, 6, 7, 8/)

    xx = 1./dx/dx
    xy = 1./dx/dy
    xz = 1./dx/dz
    yy = 1./dy/dy
    yz = 1./dy/dz
    zz = 1./dz/dz

  call init_c2()
  call init_c4()
  call init_c6()
  call init_c8()
  call init_c10()
  call init_c12()
  call init_c14()
  call init_c16()
  call init_s2()
  call init_s4()
  call init_s6()
  call init_s8()
  call init_s10()
  call init_s12()
  call init_s14()
  call init_s16()

  open(2,file="staggered_eig2.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz2 = cos(kzdz)
    ccz2 = cos(0.5*kzdz)
    ssz2 = sin(0.5*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy2 = cos(kydy)
      ccy2 = cos(0.5*kydy)
      ssy2 = sin(0.5*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx2 = cos(kxdx)
        ccx2 = cos(0.5*kxdx)
        ssx2 = sin(0.5*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*(cx2-1) &
               + v(:,2,2,:)*yy*2*(cy2-1) &
               + v(:,3,3,:)*zz*2*(cz2-1) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*(ssx2*ccy2*ccz2)*(ccx2*ssy2*ccz2) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*(ssx2*ccy2*ccz2)*(ccx2*ccy2*ssz2) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*(ccx2*ssy2*ccz2)*(ccx2*ccy2*ssz2)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(2,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz2 = cos(kzdz)
    ccz2 = cos(0.5*kzdz)
    ssz2 = sin(0.5*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy2 = cos(kydy)
      ccy2 = cos(0.5*kydy)
      ssy2 = sin(0.5*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx2 = cos(kxdx)
        ccx2 = cos(0.5*kxdx)
        ssx2 = sin(0.5*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*(cx2-1) &
               + v(:,2,2,:)*yy*2*(cy2-1) &
               + v(:,3,3,:)*zz*2*(cz2-1) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*(ssx2*ccy2*ccz2)*(ccx2*ssy2*ccz2) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*(ssx2*ccy2*ccz2)*(ccx2*ccy2*ssz2) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*(ccx2*ssy2*ccz2)*(ccx2*ccy2*ssz2)


        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(2,*) dt, maxval(eig)

 enddo

  close(2)

  open(4,file="staggered_eig4.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz4 = cos(l(1:2)*kzdz)
    ccz4 = cos((2*l(1:2)-1)/2.*kzdz)
    ssz4 = sin((2*l(1:2)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy4 = cos(l(1:2)*kydy)
      ccy4 = cos((2*l(1:2)-1)/2.*kydy)
      ssy4 = sin((2*l(1:2)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx4 = cos(l(1:2)*kxdx)
        ccx4 = cos((2*l(1:2)-1)/2.*kxdx)
        ssx4 = sin((2*l(1:2)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c4(1:2)*(cx4-1)) &
               + v(:,2,2,:)*yy*2*sum(c4(1:2)*(cy4-1)) &
               + v(:,3,3,:)*zz*2*sum(c4(1:2)*(cz4-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s4*ssx4*ccy4*ccz4)*sum(s4*ccx4*ssy4*ccz4) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s4*ssx4*ccy4*ccz4)*sum(s4*ccx4*ccy4*ssz4) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s4*ccx4*ssy4*ccz4)*sum(s4*ccx4*ccy4*ssz4)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(4,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz4 = cos(l(1:2)*kzdz)
    ccz4 = cos((2*l(1:2)-1)/2.*kzdz)
    ssz4 = sin((2*l(1:2)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy4 = cos(l(1:2)*kydy)
      ccy4 = cos((2*l(1:2)-1)/2.*kydy)
      ssy4 = sin((2*l(1:2)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx4 = cos(l(1:2)*kxdx)
        ccx4 = cos((2*l(1:2)-1)/2.*kxdx)
        ssx4 = sin((2*l(1:2)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c4(1:2)*(cx4-1)) &
               + v(:,2,2,:)*yy*2*sum(c4(1:2)*(cy4-1)) &
               + v(:,3,3,:)*zz*2*sum(c4(1:2)*(cz4-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s4*ssx4*ccy4*ccz4)*sum(s4*ccx4*ssy4*ccz4) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s4*ssx4*ccy4*ccz4)*sum(s4*ccx4*ccy4*ssz4) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s4*ccx4*ssy4*ccz4)*sum(s4*ccx4*ccy4*ssz4)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(4,*) dt, maxval(eig)

 enddo

  close(4)

  open(6,file="staggered_eig6.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz6 = cos(l(1:3)*kzdz)
    ccz6 = cos((2*l(1:3)-1)/2.*kzdz)
    ssz6 = sin((2*l(1:3)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy6 = cos(l(1:3)*kydy)
      ccy6 = cos((2*l(1:3)-1)/2.*kydy)
      ssy6 = sin((2*l(1:3)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx6 = cos(l(1:3)*kxdx)
        ccx6 = cos((2*l(1:3)-1)/2.*kxdx)
        ssx6 = sin((2*l(1:3)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c6(1:3)*(cx6-1)) &
               + v(:,2,2,:)*yy*2*sum(c6(1:3)*(cy6-1)) &
               + v(:,3,3,:)*zz*2*sum(c6(1:3)*(cz6-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s6*ssx6*ccy6*ccz6)*sum(s6*ccx6*ssy6*ccz6) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s6*ssx6*ccy6*ccz6)*sum(s6*ccx6*ccy6*ssz6) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s6*ccx6*ssy6*ccz6)*sum(s6*ccx6*ccy6*ssz6)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(6,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz6 = cos(l(1:3)*kzdz)
    ccz6 = cos((2*l(1:3)-1)/2.*kzdz)
    ssz6 = sin((2*l(1:3)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy6 = cos(l(1:3)*kydy)
      ccy6 = cos((2*l(1:3)-1)/2.*kydy)
      ssy6 = sin((2*l(1:3)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx6 = cos(l(1:3)*kxdx)
        ccx6 = cos((2*l(1:3)-1)/2.*kxdx)
        ssx6 = sin((2*l(1:3)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c6(1:3)*(cx6-1)) &
               + v(:,2,2,:)*yy*2*sum(c6(1:3)*(cy6-1)) &
               + v(:,3,3,:)*zz*2*sum(c6(1:3)*(cz6-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s6*ssx6*ccy6*ccz6)*sum(s6*ccx6*ssy6*ccz6) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s6*ssx6*ccy6*ccz6)*sum(s6*ccx6*ccy6*ssz6) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s6*ccx6*ssy6*ccz6)*sum(s6*ccx6*ccy6*ssz6)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(6,*) dt, maxval(eig)

 enddo

  close(6)

  open(8,file="staggered_eig8.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz8 = cos(l(1:4)*kzdz)
    ccz8 = cos((2*l(1:4)-1)/2.*kzdz)
    ssz8 = sin((2*l(1:4)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy8 = cos(l(1:4)*kydy)
      ccy8 = cos((2*l(1:4)-1)/2.*kydy)
      ssy8 = sin((2*l(1:4)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx8 = cos(l(1:4)*kxdx)
        ccx8 = cos((2*l(1:4)-1)/2.*kxdx)
        ssx8 = sin((2*l(1:4)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c8(1:4)*(cx8-1)) &
               + v(:,2,2,:)*yy*2*sum(c8(1:4)*(cy8-1)) &
               + v(:,3,3,:)*zz*2*sum(c8(1:4)*(cz8-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s8*ssx8*ccy8*ccz8)*sum(s8*ccx8*ssy8*ccz8) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s8*ssx8*ccy8*ccz8)*sum(s8*ccx8*ccy8*ssz8) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s8*ccx8*ssy8*ccz8)*sum(s8*ccx8*ccy8*ssz8)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(8,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz8 = cos(l(1:4)*kzdz)
    ccz8 = cos((2*l(1:4)-1)/2.*kzdz)
    ssz8 = sin((2*l(1:4)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy8 = cos(l(1:4)*kydy)
      ccy8 = cos((2*l(1:4)-1)/2.*kydy)
      ssy8 = sin((2*l(1:4)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx8 = cos(l(1:4)*kxdx)
        ccx8 = cos((2*l(1:4)-1)/2.*kxdx)
        ssx8 = sin((2*l(1:4)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c8(1:4)*(cx8-1)) &
               + v(:,2,2,:)*yy*2*sum(c8(1:4)*(cy8-1)) &
               + v(:,3,3,:)*zz*2*sum(c8(1:4)*(cz8-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s8*ssx8*ccy8*ccz8)*sum(s8*ccx8*ssy8*ccz8) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s8*ssx8*ccy8*ccz8)*sum(s8*ccx8*ccy8*ssz8) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s8*ccx8*ssy8*ccz8)*sum(s8*ccx8*ccy8*ssz8)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(8,*) dt, maxval(eig)

 enddo

  close(8)

  open(10,file="staggered_eig10.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz10 = cos(l(1:5)*kzdz)
    ccz10 = cos((2*l(1:5)-1)/2.*kzdz)
    ssz10 = sin((2*l(1:5)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy10 = cos(l(1:5)*kydy)
      ccy10 = cos((2*l(1:5)-1)/2.*kydy)
      ssy10 = sin((2*l(1:5)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx10 = cos(l(1:5)*kxdx)
        ccx10 = cos((2*l(1:5)-1)/2.*kxdx)
        ssx10 = sin((2*l(1:5)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c10(1:5)*(cx10-1)) &
               + v(:,2,2,:)*yy*2*sum(c10(1:5)*(cy10-1)) &
               + v(:,3,3,:)*zz*2*sum(c10(1:5)*(cz10-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s10*ssx10*ccy10*ccz10)*sum(s10*ccx10*ssy10*ccz10) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s10*ssx10*ccy10*ccz10)*sum(s10*ccx10*ccy10*ssz10) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s10*ccx10*ssy10*ccz10)*sum(s10*ccx10*ccy10*ssz10)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(10,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz10 = cos(l(1:5)*kzdz)
    ccz10 = cos((2*l(1:5)-1)/2.*kzdz)
    ssz10 = sin((2*l(1:5)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy10 = cos(l(1:5)*kydy)
      ccy10 = cos((2*l(1:5)-1)/2.*kydy)
      ssy10 = sin((2*l(1:5)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx10 = cos(l(1:5)*kxdx)
        ccx10 = cos((2*l(1:5)-1)/2.*kxdx)
        ssx10 = sin((2*l(1:5)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c10(1:5)*(cx10-1)) &
               + v(:,2,2,:)*yy*2*sum(c10(1:5)*(cy10-1)) &
               + v(:,3,3,:)*zz*2*sum(c10(1:5)*(cz10-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s10*ssx10*ccy10*ccz10)*sum(s10*ccx10*ssy10*ccz10) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s10*ssx10*ccy10*ccz10)*sum(s10*ccx10*ccy10*ssz10) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s10*ccx10*ssy10*ccz10)*sum(s10*ccx10*ccy10*ssz10)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(10,*) dt, maxval(eig)

 enddo

  close(10)

  open(12,file="staggered_eig12.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz12 = cos(l(1:6)*kzdz)
    ccz12 = cos((2*l(1:6)-1)/2.*kzdz)
    ssz12 = sin((2*l(1:6)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy12 = cos(l(1:6)*kydy)
      ccy12 = cos((2*l(1:6)-1)/2.*kydy)
      ssy12 = sin((2*l(1:6)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx12 = cos(l(1:6)*kxdx)
        ccx12 = cos((2*l(1:6)-1)/2.*kxdx)
        ssx12 = sin((2*l(1:6)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c12(1:6)*(cx12-1.)) &
               + v(:,2,2,:)*yy*2*sum(c12(1:6)*(cy12-1.)) &
               + v(:,3,3,:)*zz*2*sum(c12(1:6)*(cz12-1.)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s12*ssx12*ccy12*ccz12)*sum(s12*ccx12*ssy12*ccz12) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s12*ssx12*ccy12*ccz12)*sum(s12*ccx12*ccy12*ssz12) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s12*ccx12*ssy12*ccz12)*sum(s12*ccx12*ccy12*ssz12)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(12,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz12 = cos(l(1:6)*kzdz)
    ccz12 = cos((2*l(1:6)-1)/2.*kzdz)
    ssz12 = sin((2*l(1:6)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy12 = cos(l(1:6)*kydy)
      ccy12 = cos((2*l(1:6)-1)/2.*kydy)
      ssy12 = sin((2*l(1:6)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx12 = cos(l(1:6)*kxdx)
        ccx12 = cos((2*l(1:6)-1)/2.*kxdx)
        ssx12 = sin((2*l(1:6)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c12(1:6)*(cx12-1.)) &
               + v(:,2,2,:)*yy*2*sum(c12(1:6)*(cy12-1.)) &
               + v(:,3,3,:)*zz*2*sum(c12(1:6)*(cz12-1.)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s12*ssx12*ccy12*ccz12)*sum(s12*ccx12*ssy12*ccz12) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s12*ssx12*ccy12*ccz12)*sum(s12*ccx12*ccy12*ssz12) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s12*ccx12*ssy12*ccz12)*sum(s12*ccx12*ccy12*ssz12)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(12,*) dt, maxval(eig)

 enddo

  close(12)

  open(14,file="staggered_eig14.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz14 = cos(l(1:7)*kzdz)
    ccz14 = cos((2*l(1:7)-1)/2.*kzdz)
    ssz14 = sin((2*l(1:7)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy14 = cos(l(1:7)*kydy)
      ccy14 = cos((2*l(1:7)-1)/2.*kydy)
      ssy14 = sin((2*l(1:7)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx14 = cos(l(1:7)*kxdx)
        ccx14 = cos((2*l(1:7)-1)/2.*kxdx)
        ssx14 = sin((2*l(1:7)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c14(1:7)*(cx14-1)) &
               + v(:,2,2,:)*yy*2*sum(c14(1:7)*(cy14-1)) &
               + v(:,3,3,:)*zz*2*sum(c14(1:7)*(cz14-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s14*ssx14*ccy14*ccz14)*sum(s14*ccx14*ssy14*ccz14) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s14*ssx14*ccy14*ccz14)*sum(s14*ccx14*ccy14*ssz14) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s14*ccx14*ssy14*ccz14)*sum(s14*ccx14*ccy14*ssz14)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(14,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz14 = cos(l(1:7)*kzdz)
    ccz14 = cos((2*l(1:7)-1)/2.*kzdz)
    ssz14 = sin((2*l(1:7)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy14 = cos(l(1:7)*kydy)
      ccy14 = cos((2*l(1:7)-1)/2.*kydy)
      ssy14 = sin((2*l(1:7)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx14 = cos(l(1:7)*kxdx)
        ccx14 = cos((2*l(1:7)-1)/2.*kxdx)
        ssx14 = sin((2*l(1:7)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c14(1:7)*(cx14-1)) &
               + v(:,2,2,:)*yy*2*sum(c14(1:7)*(cy14-1)) &
               + v(:,3,3,:)*zz*2*sum(c14(1:7)*(cz14-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s14*ssx14*ccy14*ccz14)*sum(s14*ccx14*ssy14*ccz14) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s14*ssx14*ccy14*ccz14)*sum(s14*ccx14*ccy14*ssz14) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s14*ccx14*ssy14*ccz14)*sum(s14*ccx14*ccy14*ssz14)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(14,*) dt, maxval(eig)

 enddo

  close(14)

  open(16,file="staggered_eig16.txt",form="formatted")

  dtt = 0.0001

 do it=1,21
  write(0,*) it

  dt = (it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz16 = cos(l(1:8)*kzdz)
    ccz16 = cos((2*l(1:8)-1)/2.*kzdz)
    ssz16 = sin((2*l(1:8)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy16 = cos(l(1:8)*kydy)
      ccy16 = cos((2*l(1:8)-1)/2.*kydy)
      ssy16 = sin((2*l(1:8)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx16 = cos(l(1:8)*kxdx)
        ccx16 = cos((2*l(1:8)-1)/2.*kxdx)
        ssx16 = sin((2*l(1:8)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c16(1:8)*(cx16-1)) &
               + v(:,2,2,:)*yy*2*sum(c16(1:8)*(cy16-1)) &
               + v(:,3,3,:)*zz*2*sum(c16(1:8)*(cz16-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s16*ssx16*ccy16*ccz16)*sum(s16*ccx16*ssy16*ccz16) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s16*ssx16*ccy16*ccz16)*sum(s16*ccx16*ccy16*ssz16) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s16*ccx16*ssy16*ccz16)*sum(s16*ccx16*ccy16*ssz16)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(16,*) dt, maxval(eig)

 enddo

  dtt = 0.001

 do it=1,8
  write(0,*) it

  dt = 0.003+(it-1)*dtt

  do i3=1,101
    kzdz = -pi + (i3-1)*d
    cz16 = cos(l(1:8)*kzdz)
    ccz16 = cos((2*l(1:8)-1)/2.*kzdz)
    ssz16 = sin((2*l(1:8)-1)/2.*kzdz)

    do i2=1,101
      kydy = -pi + (i2-1)*d
      cy16 = cos(l(1:8)*kydy)
      ccy16 = cos((2*l(1:8)-1)/2.*kydy)
      ssy16 = sin((2*l(1:8)-1)/2.*kydy)

      do i1=1,101
        kxdx = -pi + (i1-1)*d
        cx16 = cos(l(1:8)*kxdx)
        ccx16 = cos((2*l(1:8)-1)/2.*kxdx)
        ssx16 = sin((2*l(1:8)-1)/2.*kxdx)
        
        A(:,:) = v(:,1,1,:)*xx*2*sum(c16(1:8)*(cx16-1)) &
               + v(:,2,2,:)*yy*2*sum(c16(1:8)*(cy16-1)) &
               + v(:,3,3,:)*zz*2*sum(c16(1:8)*(cz16-1)) &
              - (v(:,1,2,:) + v(:,2,1,:))*4*xy*sum(s16*ssx16*ccy16*ccz16)*sum(s16*ccx16*ssy16*ccz16) &
              - (v(:,1,3,:) + v(:,3,1,:))*4*xz*sum(s16*ssx16*ccy16*ccz16)*sum(s16*ccx16*ccy16*ssz16) &
              - (v(:,2,3,:) + v(:,3,2,:))*4*yz*sum(s16*ccx16*ssy16*ccz16)*sum(s16*ccx16*ccy16*ssz16)

        B = 0.
        B(1:3,1:3) = A*dt*dt + I
        B(1:3,4:6) = -I
        B(4:6,1:3) = I
        B(4:6,4:6) = -I
        
        call dgees('N', 'N', select, 6, B, 6, sdim, wr, wi, vs, 6, work, 18, bwork, info)

        eig(i1,i2,i3) = maxval(sqrt((wr+1)*(wr+1) + wi*wi))

      enddo
    enddo
  enddo
 
  write(16,*) dt, maxval(eig)

 enddo

  close(16)

  call sep_close()

end program sstability

logical function select(u,v)

  implicit none

  double precision :: u, v

  select = .true.

end function
